/*
 * FILE:
 *   cg_image.hpp
 *
 * PURPOSE:
 *   Coercri implementation of gcn::Image
 *   
 * AUTHOR:
 *   Stephen Thompson, 2008
 *
 * COPYRIGHT:
 *   Public Domain
 *
 */

#ifndef COERCRI_CG_IMAGE_HPP
#define COERCRI_CG_IMAGE_HPP

#include "guichan.hpp"

namespace Coercri {

    class Graphic;
    
    class CGImage : public gcn::Image {
    public:

        const Graphic & getGraphic() const;
        
        // Overriden from gcn::Image:
        virtual void free();
        virtual int getWidth() const;
        virtual int getHeight() const;
        virtual gcn::Color getPixel(int x, int y);
        virtual void putPixel(int x, int y, const gcn::Color &color);
        virtual void convertToDisplayFormat();
    };
}

#endif
