/*
 * FILE:
 *   raw_key.hpp
 *
 * PURPOSE:
 *   Keycodes for "raw" keys.
 *
 * AUTHOR:
 *   Stephen Thompson, 2008
 *
 * COPYRIGHT:
 *   Public Domain
 *
 */

#ifndef COERCRI_RAW_KEY_HPP
#define COERCRI_RAW_KEY_HPP

#include <string>

namespace Coercri {

    // NOTE: New RawKey codes should be added at the END, so that programs relying on
    // the existing numeric codes do not break.
    
    enum RawKey {
        RK_0,
        RK_1,
        RK_2,
        RK_3,
        RK_4,
        RK_5,
        RK_6,
        RK_7,
        RK_8,
        RK_9,
        RK_A,
        RK_AMPERSAND,
        RK_ASTERISK,
        RK_AT,
        RK_B,
        RK_BACKQUOTE,
        RK_BACKSLASH,
        RK_BACKSPACE,
        RK_BREAK,
        RK_C,
        RK_CAPS_LOCK,
        RK_CARET,
        RK_CLEAR,
        RK_COLON,
        RK_COMMA,
        RK_COMPOSE,
        RK_D,
        RK_DELETE,
        RK_DOLLAR,
        RK_DOUBLE_QUOTE,
        RK_DOWN,
        RK_E,
        RK_END,
        RK_EQUALS,
        RK_ESCAPE,
        RK_EURO,
        RK_EXCLAIM,
        RK_F,
        RK_F1,
        RK_F2,
        RK_F3,
        RK_F4,
        RK_F5,
        RK_F6,
        RK_F7,
        RK_F8,
        RK_F9,
        RK_F10,
        RK_F11,
        RK_F12,
        RK_F13,
        RK_F14,
        RK_F15,
        RK_G,
        RK_GREATER,
        RK_H,
        RK_HASH,
        RK_HELP,
        RK_HOME,
        RK_I,
        RK_INSERT,
        RK_J,
        RK_K,
        RK_KP_0,
        RK_KP_1,
        RK_KP_2,
        RK_KP_3,
        RK_KP_4,
        RK_KP_5,
        RK_KP_6,
        RK_KP_7,
        RK_KP_8,
        RK_KP_9,
        RK_KP_DIVIDE,
        RK_KP_ENTER,
        RK_KP_EQUALS,
        RK_KP_MINUS,
        RK_KP_MULTIPLY,
        RK_KP_PERIOD,
        RK_KP_PLUS,
        RK_L,
        RK_LEFT,
        RK_LEFT_ALT,
        RK_LEFT_BRACKET,
        RK_LEFT_CONTROL,
        RK_LEFT_META,
        RK_LEFT_PAREN,
        RK_LEFT_SHIFT,
        RK_LEFT_SUPER,
        RK_LESS,
        RK_M,
        RK_MENU,
        RK_MODE,
        RK_MINUS,
        RK_N,
        RK_NUM_LOCK,
        RK_O,
        RK_P,
        RK_PAGE_DOWN,
        RK_PAGE_UP,
        RK_PAUSE,
        RK_PERIOD,
        RK_PLUS,
        RK_POWER,
        RK_PRINT,
        RK_Q,
        RK_QUESTION,
        RK_R,
        RK_RETURN,
        RK_RIGHT,
        RK_RIGHT_ALT,
        RK_RIGHT_BRACKET,
        RK_RIGHT_CONTROL,
        RK_RIGHT_META,
        RK_RIGHT_PAREN,
        RK_RIGHT_SHIFT,
        RK_RIGHT_SUPER,
        RK_S,
        RK_SCROLL_LOCK,
        RK_SEMICOLON,
        RK_SINGLE_QUOTE,
        RK_SLASH,
        RK_SPACE,
        RK_SYSREQ,
        RK_T,
        RK_TAB,
        RK_U,
        RK_UNDERSCORE,
        RK_UNDO,
        RK_UP,
        RK_V,
        RK_W,
        RK_X,
        RK_Y,
        RK_Z
    };

    std::string RawKeyName(RawKey r);

}

#endif
