/*
 * FILE:
 *   sdl_timer.cpp
 *
 * PURPOSE:
 *   SDL implementation of Timer interface
 *
 * AUTHOR:
 *   Stephen Thompson, 2008
 *
 * COPYRIGHT:
 *   Public Domain
 *
 */

#include "sdl_timer.hpp"

#include "SDL.h"

namespace Coercri {

    SDLTimer::SDLTimer()
        : timer_subsystem(SDL_INIT_TIMER)
    { }

    unsigned int SDLTimer::getMsec()
    {
        return SDL_GetTicks();
    }

    void SDLTimer::sleepMsec(int msec)
    {
        SDL_Delay(msec);
    }
}
