/*
 * command_codes.hpp
 *
 * Codes for network commands.
 *
 * Copyright (c) Stephen Thompson, 2008.
 * Licensed for non-commercial use only. See LICENCE.txt for details.
 *
 */

#ifndef COMMAND_CODES_HPP
#define COMMAND_CODES_HPP

enum CommandCode {
    C_SET_CURRENT_ROOM,       // 0
    C_MAP_CURRENT_ROOM,       // 1
    C_MAP_WALL,               // 2
    C_MAP_KNIGHT_LOCATION,    // 3
    C_MAP_ITEM_LOCATION,      // 4
    C_WIPE_MAP,               // 5
    C_ADD_ENTITY,             // 6
    C_RM_ENTITY,              // 7
    C_REPOSITION_ENTITY,      // 8
    C_MOVE_ENTITY,            // 9
    C_SET_ANIM_DATA,          // 10
    C_SET_FACING,             // 11
    C_CLEAR_TILES,            // 12
    C_SET_TILE,               // 13
    C_SET_ITEM,               // 14
    C_PLACE_ICON,             // 15
    C_SET_BACKPACK,           // 16
    C_ADD_SKULL,              // 17
    C_SET_HEALTH,             // 18
    C_SET_POTION_MAGIC,       // 19
    C_FLASH_MESSAGE,          // 20
    C_CANCEL_CONTINUOUS_MESSAGES,    // 21
    C_ADD_CONTINUOUS_MESSAGE,        // 22
    C_FLASH_SCREEN,           // 23
    C_SET_AVAILABLE_CONTROLS, // 24
    C_SET_MENU_HIGHLIGHT,     // 25
    C_WIN_GAME,               // 26
    C_LOSE_GAME,              // 27
    C_QUIT_GAME,              // 28
    C_PLAY_SOUND,             // 29
    C_FLIP_ENTITY_MOTION      // 30
};

#endif
