/*
 * control.cpp
 *
 * Copyright (c) Stephen Thompson, 2008.
 * Licensed for non-commercial use only. See LICENCE.txt for details.
 *
 */

#include "misc.hpp"

#include "client_config.hpp"
#include "control.hpp"
#include "gfx_manager.hpp"

Control * g_standard_controls[NUM_STANDARD_CONTROLS];

void Control::serialize(Coercri::NetworkConnection &remote, const GfxManager &gm, int new_id)
{
    id = new_id;
    // Note: Action is not serialized
    remote.putUshort(menu_graphic? gm.getGraphicID(*menu_graphic) : 0);
    remote.putUbyte(menu_dir + 128*int(cts));
    remote.putUbyte(tap_pri);
    remote.putUbyte(menu_special);
}

Control::Control(Coercri::NetworkConnection &remote, const ClientConfig &conf, int new_id)
    : id(new_id), action(0)
{
    menu_graphic = conf.getGraphic(remote.getUshort());
    unsigned short x = remote.getUbyte();
    menu_dir = MapDirection(x & 0x7f);
    cts = (x>=128);
    tap_pri = remote.getUbyte();
    menu_special = remote.getUbyte();
}

