/*
 * loading_screen.hpp
 *
 * Loading Screen
 * --- servers or local: loads ServerConfig
 * --- server: sends config to client
 * --- client: receives config from server
 * Sets KnightsGame::server_config or KnightsGame::client_config
 * Continues to MenuScreen.
 * 
 * Copyright (c) Stephen Thompson, 2008.
 * Licensed for non-commercial use only. See LICENCE.txt for details.
 *
 */

#ifndef LOADING_SCREEN_HPP
#define LOADING_SCREEN_HPP

#include "screen.hpp"

class LoadingScreen : public Screen {
public:
    LoadingScreen() : knights_game(0) { }
    virtual bool start(KnightsGame &knights_game, shared_ptr<Coercri::Window> window, gcn::Gui &gui);
    virtual ~LoadingScreen();
    virtual unsigned int getUpdateInterval() { return 50; }
    virtual void update();
private:
    shared_ptr<Coercri::Window> window;
    shared_ptr<Coercri::WindowListener> window_listener;
    KnightsGame *knights_game;
};

#endif

