/*
 * sound_manager.hpp
 *
 * Keeps track of all loaded sounds
 * 
 * Copyright (c) Stephen Thompson, 2008.
 * Licensed for non-commercial use only. See LICENCE.txt for details.
 *
 */

#ifndef SOUND_MANAGER_HPP
#define SOUND_MANAGER_HPP

#include "coercri/sound/sound_driver.hpp"

#include "boost/shared_ptr.hpp"
using namespace boost;

#include <map>
#include <string>
using namespace std;

class SoundManager {
public:
    explicit SoundManager(shared_ptr<Coercri::SoundDriver> d) : sound_driver(d) { }
    
    void loadSound(const string &name);
    void playSound(const string &name, int frequency);
    void clear();  // unloads all sounds.
    
private:
    shared_ptr<Coercri::SoundDriver> sound_driver;
    map<string, shared_ptr<Coercri::Sound> > sound_map;
};

#endif
